#pragma once

#include <d3d9.h>
#include <d3dx9.h>

class Model
{

public:
	LPD3DXMESH Mesh;
	D3DMATERIAL9* Materials;
	DWORD numMaterials;
	LPDIRECT3DTEXTURE9* Textures;
    D3DXVECTOR3 minBound, maxBound;        // bounding box


    float calibrationAngleX, calibrationAngleY, calibrationAngleZ;

    Model()
    {
        Mesh = 0;
        Materials = NULL;
        numMaterials = 0;
        Textures = NULL;
        calibrationAngleX = 0;
        calibrationAngleY = 0;
        calibrationAngleZ = 0;
    }

	~Model()
	{
		delete [] Materials;
		delete [] Textures;
	}
};