//===============================================================================
// @ IvAssert.h
// 
// Assertion macros
// ------------------------------------------------------------------------------
// Copyright (C) 2004 by Elsevier, Inc. All rights reserved.
//
//===============================================================================

#ifndef __IvAssert__h__
#define __IvAssert__h__

//-------------------------------------------------------------------------------
//-- Dependencies ---------------------------------------------------------------
//-------------------------------------------------------------------------------

#include <assert.h>
#include "IvDebugger.h"

//-------------------------------------------------------------------------------
//-- Typedefs, Structs ----------------------------------------------------------
//-------------------------------------------------------------------------------

#ifndef ASSERT

#ifdef _DEBUG
#define ASSERT(x) \
    if (!(x)) \
        DEBUG_OUT( "Assertion failed: file " << __FILE__ << " line " << __LINE__ << eol ); \
    assert(x)
#else
#define ASSERT(x)
#endif

#endif

#endif
